<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: Experiment.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Experiment.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Experiment_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/* </span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * File:   Experiment.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Author: cfmadmin</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * Created on December 11, 2012, 6:01 PM</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef EXPERIMENT_HPP</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define EXPERIMENT_HPP</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="FileManager_8hpp.html">FileManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="StateManager_8hpp.html">StateManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="HardwareManager_8hpp.html">HardwareManager.hpp</a>&quot;</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="DataLogger_8hpp.html">DataLogger.hpp</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Factory_8hpp.html">Factory.hpp</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Robot_8hpp.html">Robot.hpp</a>&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//class Robot;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">//class HardwareManager;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;</div>
<div class="line"><a name="l00023"></a><span class="lineno"><a class="code" href="classExperiment.html">   23</a></span>&#160;<span class="keyword">class </span><a class="code" href="classExperiment.html">Experiment</a> {</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <a class="code" href="classExperiment.html#a303e6a05d99f403ff4793495a2fbff58">Experiment</a>();</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="comment">/*Experiment(const Experiment&amp; orig);*/</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classExperiment.html#a96058d848040e45948bbb60623711da6">~Experiment</a>();</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classExperiment.html#a2666b3fed68eef734107a0251ce405ce">Initialize</a>();</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classExperiment.html#a8a0883ab9e784e03764e48e696e9326d">Run</a>();</div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="code" href="classExperiment.html#a618e7c46eeff8b7929325faa200ef26d">   34</a></span>&#160;    QString <a class="code" href="classExperiment.html#a618e7c46eeff8b7929325faa200ef26d">getExperimentDirAbsolute</a>()</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    {</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classExperiment.html#a5dddf66033c1647de6887ae478616021">_fileManager</a>.<a class="code" href="classFileManager.html#a10b093c38ffeeee2da54a22234856ad2">getExperimentDirAbsolute</a>();</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    }</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <a class="code" href="classFileManager.html">FileManager</a>&amp; <a class="code" href="classExperiment.html#a66f0d618c92aba22b1608f1463ba73b6">fileManager</a>();</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <a class="code" href="classStateManager.html">StateManager</a>&amp; <a class="code" href="classExperiment.html#a08348cb9f17221c846c3a060536aba41">stateManager</a>();</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="code" href="classExperiment.html#aee5dc7e1ab2b81608a7e410a2965b125">   41</a></span>&#160;    <a class="code" href="classHardwareManager.html">HardwareManager</a>&amp; <a class="code" href="classExperiment.html#aee5dc7e1ab2b81608a7e410a2965b125" title="needs to be able to initialize logger with path suppplied by fileManager">hardwareManager</a>()  <span class="comment">//TODO: can we avoid making it public .. ?</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classExperiment.html#a5ff303d8500ff59b299949927ab28cf7">_hardwareManager</a>;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <a class="code" href="classRobot.html">Robot</a>&amp; <a class="code" href="classExperiment.html#a6a36bf1369f8182b04521945d6cd7602">robot</a>();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    </div>
<div class="line"><a name="l00047"></a><span class="lineno"><a class="code" href="classExperiment.html#a56c8d186c0f14e64259ec07a0828cab4">   47</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classExperiment.html#a56c8d186c0f14e64259ec07a0828cab4">TimeElapsedMs</a>()</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classExperiment.html#aea02f08fda51ead05d12b59f9b08faa8">_timer</a>.<a class="code" href="classTimer.html#a90949155d335a3edec5efb209270e285">TimeElapsedMs</a>();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    }</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="code" href="classExperiment.html#a5dddf66033c1647de6887ae478616021">   53</a></span>&#160;   <a class="code" href="classFileManager.html">FileManager</a> <a class="code" href="classExperiment.html#a5dddf66033c1647de6887ae478616021">_fileManager</a>;</div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="code" href="classExperiment.html#a6bd067df8c3101694f7ea7dc5b627ec4">   54</a></span>&#160;   <a class="code" href="classStateManager.html">StateManager</a> <a class="code" href="classExperiment.html#a6bd067df8c3101694f7ea7dc5b627ec4">_stateManager</a>;       </div>
<div class="line"><a name="l00055"></a><span class="lineno"><a class="code" href="classExperiment.html#aea02f08fda51ead05d12b59f9b08faa8">   55</a></span>&#160;   <a class="code" href="classTimer.html">Timer</a> <a class="code" href="classExperiment.html#aea02f08fda51ead05d12b59f9b08faa8">_timer</a>;</div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="code" href="classExperiment.html#a5ff303d8500ff59b299949927ab28cf7">   56</a></span>&#160;   <a class="code" href="classHardwareManager.html">HardwareManager</a> <a class="code" href="classExperiment.html#a5ff303d8500ff59b299949927ab28cf7">_hardwareManager</a>;</div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="code" href="classExperiment.html#a40ca4ea7a8abb75c6108ab186b12ba31">   57</a></span>&#160;   <a class="code" href="classRobot.html">Robot</a> <a class="code" href="classExperiment.html#a40ca4ea7a8abb75c6108ab186b12ba31">_robot</a>;</div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="code" href="classExperiment.html#a5be17d7d003f13cf9585f616d14167dd">   58</a></span>&#160;   <a class="code" href="Factory_8hpp.html#ac382ea009b4d4cfc84e9bde8ea23392e">ProtocolPtr</a> <a class="code" href="classExperiment.html#a5be17d7d003f13cf9585f616d14167dd">protocol</a>;  </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;};</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* EXPERIMENT_HPP */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;<span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
